function lab = xyz2labn(xyz,xyzn)
    %converts Nx3 xyz values to Lab given reference white coords xyzn.
    %by Jack Hogan version 0.12
    if nargin < 2
        xyzn = [0.96422 1 0.82521];         %default white ref = D50
              %[0.95047; 1.00000; 1.08883]; %D65
    end
    
    fx = f(xyz(:,1)/xyzn(1));
    fy = f(xyz(:,2)/xyzn(2));
    fz = f(xyz(:,3)/xyzn(3));
    
    lab = [116*fy-16, 500*(fx-fy), 200*(fy - fz)];
    
    function y = f(t)
        y = zeros(size(t));
        sigma = 6/29;
        gt = t > sigma^3;
        y(gt) = t(gt).^(1/3);
        y(~gt) =  t(~gt)/3/sigma^2 + 4/29;
    end
end